package vishnu.util;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Misc {

    // quickSort
    private static void qs(int l, int r, double v[][])
    {
	if( l < r )
	{
		int i = l;
		int j = r;
		double pivot = v[1][(l+r)/2];
		do
		{

			while( v[1][i] < pivot )
			{
				i++;
			} 
			while( v[1][j] > pivot )
			{
				j--;
			}

			if( i <= j )
			{
				if( i < j )
				{
					double t1 = v[1][i];	
					double t0 = v[0][i];
					v[1][i] = v[1][j];
					v[1][j] = t1;
					v[0][i] = v[0][j];
					v[0][j] = t0;
				}
				i++;
				j--;
			}
		
		}
		while( i <= j );
		qs(l,j,v);
		qs(i,r,v);
		
	}
    }

    
    
    // quickSort
    private static void qs(int l, int r, double v[])
    {
	if( l < r )
	{
		int i = l;
		int j = r;
		double pivot = v[(l+r)/2];
		do
		{

			while( v[i] < pivot )
			{
				i++;
			} 
			while( v[j] > pivot )
			{
				j--;
			}

			if( i <= j )
			{
				if( i < j )
				{
					double t1 = v[i];	
					v[i] = v[j];
					v[j] = t1;
				}
				i++;
				j--;
			}
		
		}
		while( i <= j );
		qs(l,j,v);
		qs(i,r,v);
		
	}
    }


 // quickSort
    private static void qs(int l, int r, int v[])
    {
	if( l < r )
	{
		int i = l;
		int j = r;
		int pivot = v[(l+r)/2];
		do
		{

			while( v[i] < pivot )
			{
				i++;
			} 
			while( v[j] > pivot )
			{
				j--;
			}

			if( i <= j )
			{
				if( i < j )
				{
					int t1 = v[i];	
					v[i] = v[j];
					v[j] = t1;
				}
				i++;
				j--;
			}
		
		}
		while( i <= j );
		qs(l,j,v);
		qs(i,r,v);
	}
    }


 // quickSort
    private static void qs(int l, int r, int[] v, Object[] objArr)
    {
        if( l < r ){
            int i = l;
            int j = r;

            int pivot = v[(l+r)/2];

            do{
                while( v[i] < pivot ){
                    i++;
                }
                while( v[j] > pivot ){
                    j--;
                }

                if( i <= j ){
                    if( i < j ){
                        int t1 = v[i];
                        v[i] = v[j];
                        v[j] = t1;

                        Object tobj = objArr[i];
                        objArr[i] = objArr[j];
                        objArr[j] = tobj;
 }
                    i++;
                    j--;
                }

            }
            while( i <= j );
            qs(l,j,v,objArr);
            qs(i,r,v,objArr);
        }
    }


    // quickSort
    private static void qs(int l, int r, float[] v, Object[] objArr)
    {
	if( l < r ){
	    int i = l;
	    int j = r;
	    
	    float pivot = v[(l+r)/2];
	    
	    do{
		while( v[i] < pivot ){
		    i++;
		} 
		while( v[j] > pivot ){
		    j--;
		}
		
		if( i <= j ){
		    if( i < j ){
			float t1 = v[i];	
			v[i] = v[j];
			v[j] = t1;
			
			Object tobj = objArr[i];
			objArr[i] = objArr[j];
			objArr[j] = tobj;
		    }
		    i++;
		    j--;
		}
		
	    }
	    while( i <= j );
	    qs(l,j,v,objArr);
	    qs(i,r,v,objArr);
	}
    }
    

    public static void quickSort(int[] v)
    {
	qs(0,v.length-1,v);
    }

    public static void quickSort(float[] v, Object[] objArr)
    {
	qs(0,v.length-1,v,objArr);
    }

    public static void quickSort(int[] v, Object[] objArr)
    {
	qs(0,v.length-1,v,objArr);
    }

    public static void quickSort(double v[])
    {
	qs(0,v.length-1,v);
    }


    public static void quickSort(double v[][])
    {
	qs(0,v[0].length-1,v);
    }
}
    
    
